Package tigase.xmpp.impl

## Class FlexibleOfflineMessageRetrieval

- java.lang.Object
- - tigase.xmpp.XMPPProcessor
  - - tigase.xmpp.impl.annotation.AnnotatedXMPPProcessor
    - - tigase.xmpp.XMPPProcessorAbstract
      - - tigase.xmpp.impl.FlexibleOfflineMessageRetrieval

- All Implemented Interfaces:
    `java.lang.Comparable<XMPPImplIfc>`, `XMPPImplIfc`, `XMPPProcessorConcurrencyAwareIfc`, `XMPPProcessorIfc`

      @Bean(name="http://jabber.org/protocol/offline",
            parent=SessionManager.class,
            active=false)
      public class FlexibleOfflineMessageRetrieval
      extends XMPPProcessorAbstract
      implements XMPPProcessorIfc

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static java.lang.String` | `FLEXIBLE_OFFLINE_XMLNS` | Field holds the xmlns of XEP-0013: Flexible offline messages retrieval
    `protected static java.lang.String` | `ID` |
    `static java.lang.String` | `ITEM_ELEMENT_NAME` |
    `static java.lang.String[]` | `MESSAGE_EVENT_PATH` |
    `static java.lang.String[]` | `MESSAGE_HEADER_PATH` |
    `static java.lang.String` | `NODE_ATTRIBUTE_NAME` |

    - ### Fields inherited from class tigase.xmpp.XMPPProcessor

      `ALL_NAMES, ALL_PATHS, cmpInfo`

    - ### Fields inherited from interface tigase.xmpp.XMPPImplIfc

      `CLIENT_XMLNS`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `FlexibleOfflineMessageRetrieval()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `Authorization` | `canHandle​(Packet packet, XMPPResourceConnection conn)` | By default the method uses `XMPPImplIfc.supElementNamePaths()` and `XMPPImplIfc.supTypes()` method results to determine whether the plugin would process given packet.
    `java.lang.String` | `id()` | Method `id` returns a unique ID of the plugin.
    `void` | `processFromUserToServerPacket​(JID connectionId, Packet packet, XMPPResourceConnection session, NonAuthUserRepository repo, java.util.Queue<Packet> results, java.util.Map<java.lang.String,​java.lang.Object> settings)` | The method is called when a packet is send from the user who is owner of the session to the local server (ping, roster management, privacy lists, etc...).
    `void` | `processServerSessionPacket​(Packet packet, XMPPResourceConnection session, NonAuthUserRepository repo, java.util.Queue<Packet> results, java.util.Map<java.lang.String,​java.lang.Object> settings)` | The method is called when a packet addressed to the server domain is received.
    `java.util.Queue<Packet>` | `restorePacketForOffLineUser​(java.util.List<java.lang.String> db_ids, XMPPResourceConnection conn, MsgRepositoryIfc repo)` |
    `Element[]` | `supDiscoFeatures​(XMPPResourceConnection session)` | Method `supDiscoFeatures` returns an array of XML `Element`s with service discovery features which have to be returned to the client uppon request.
    `java.lang.String[][]` | `supElementNamePaths()` | Method `supElementNamePaths` returns an array of element names in form of a full path to the XML element for stanzas which can be processed by this plugin.
    `java.lang.String[]` | `supNamespaces()` | Method `supNamespaces` returns an array of name-spaces for stanzas which can be processed by this plugin.

    - ### Methods inherited from class tigase.xmpp.XMPPProcessorAbstract

      `isFromUserSession, isNullSession, isServerSession, isToUserSession, process, processFromUserOutPacket, processFromUserPacket, processNullSessionPacket, processToUserPacket`

    - ### Methods inherited from class tigase.xmpp.impl.annotation.AnnotatedXMPPProcessor

      `supStreamFeatures, supTypes`

    - ### Methods inherited from class tigase.xmpp.XMPPProcessor

      `compareTo, concurrentQueuesNo, getComponentInfo, getInstance, getQueueSize, getStatistics, getThreadsNo, init, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface java.lang.Comparable

      `compareTo`

    - ### Methods inherited from interface tigase.xmpp.XMPPImplIfc

      `concurrentQueuesNo, getComponentInfo, getStatistics, init, supStreamFeatures, supTypes`

    - ### Methods inherited from interface tigase.xmpp.XMPPProcessorIfc

      `process`

- - ### Field Detail

    - #### FLEXIBLE_OFFLINE_XMLNS

          public static final java.lang.String FLEXIBLE_OFFLINE_XMLNS

      Field holds the xmlns of XEP-0013: Flexible offline messages retrieval
      See Also:
        Constant Field Values

    - #### ITEM_ELEMENT_NAME

          public static final java.lang.String ITEM_ELEMENT_NAME

      See Also:
        Constant Field Values

    - #### NODE_ATTRIBUTE_NAME

          public static final java.lang.String NODE_ATTRIBUTE_NAME

      See Also:
        Constant Field Values

    - #### MESSAGE_EVENT_PATH

          public static final java.lang.String[] MESSAGE_EVENT_PATH

    - #### MESSAGE_HEADER_PATH

          public static final java.lang.String[] MESSAGE_HEADER_PATH

    - #### ID

          protected static final java.lang.String ID

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### FlexibleOfflineMessageRetrieval

          public FlexibleOfflineMessageRetrieval()

  - ### Method Detail

    - #### canHandle

          public Authorization canHandle​(Packet packet,
                                         XMPPResourceConnection conn)

      Description copied from interface: `XMPPImplIfc`
      By default the method uses `XMPPImplIfc.supElementNamePaths()` and `XMPPImplIfc.supTypes()` method results to determine whether the plugin would process given packet. However, a plugin can implement own logic to determine packet processing capabilities or conditions. Please note, this method must be very fast and efficient. No I/O processing is recommended as it may impact performance of the whole system.
      Specified by:
        `canHandle` in interface `XMPPImplIfc`
      Overrides:
        `canHandle` in class `XMPPProcessor`
      Parameters:
        `packet` - is a `Packet` for processing.
        `conn` - is a user session object or null.
      Returns:
        returns `Authorization` enum value or null. Null means the plugin is simply not processing the packet. `Authorization.AUTHORIZED` means the plugin can process the packet, any other `Authorization` enum value means an error which has to be returned to the sender.

    - #### id

          public java.lang.String id()

      Description copied from interface: `XMPPImplIfc`
      Method `id` returns a unique ID of the plugin. Each plugin has own, unique ID which is used in the configuration file to determine whether it needs to be loaded or not. In most cases the ID can be equal to XMLNS of the packages processed by the plugin.
      Specified by:
        `id` in interface `XMPPImplIfc`
      Overrides:
        `id` in class `AnnotatedXMPPProcessor`
      Returns:
        a `String` value

    - #### processFromUserToServerPacket

          public void processFromUserToServerPacket​(JID connectionId,
                                                    Packet packet,
                                                    XMPPResourceConnection session,
                                                    NonAuthUserRepository repo,
                                                    java.util.Queue<Packet> results,
                                                    java.util.Map<java.lang.String,​java.lang.Object> settings)
                                             throws PacketErrorTypeException

      Description copied from class: `XMPPProcessorAbstract`
      The method is called when a packet is send from the user who is owner of the session to the local server (ping, roster management, privacy lists, etc...). There is no default implementation for the method.
      Specified by:
        `processFromUserToServerPacket` in class `XMPPProcessorAbstract`
      Parameters:
        `connectionId` - is a `JID` instance with the session connection ID.
        `packet` - is a `Packet` sent by the user.
        `session` - is a `XMPPResourceConnection` instance with all the sending user session data.
        `repo` - is a `NonAuthUserRepository` instance giving access to a part of the user repository which is accessible regardless the session is authenticated or not.
        `results` - is a packets `Queue` with all the processing results from the plugin.
        `settings` - is a `Map` with all the configuration settings passed to the plugin.
      Throws:
        `PacketErrorTypeException` - on attempt to send an error response to the error packet.

    - #### restorePacketForOffLineUser

          public java.util.Queue<Packet> restorePacketForOffLineUser​(java.util.List<java.lang.String> db_ids,
                                                                     XMPPResourceConnection conn,
                                                                     MsgRepositoryIfc repo)
                                                              throws UserNotFoundException,
                                                                     NotAuthorizedException

      Throws:
        `UserNotFoundException`
        `NotAuthorizedException`

    - #### processServerSessionPacket

          public void processServerSessionPacket​(Packet packet,
                                                 XMPPResourceConnection session,
                                                 NonAuthUserRepository repo,
                                                 java.util.Queue<Packet> results,
                                                 java.util.Map<java.lang.String,​java.lang.Object> settings)
                                          throws PacketErrorTypeException

      Description copied from class: `XMPPProcessorAbstract`
      The method is called when a packet addressed to the server domain is received. Please note, if a local user sends a packet to the server, the packet is handled by the `processFromUserPacket(...)` method. This method is not called for such packets.
      Specified by:
        `processServerSessionPacket` in class `XMPPProcessorAbstract`
      Parameters:
        `packet` - is a `Packet` received by the server and addressed to the server - the server virtual domain name.
        `session` - is a `XMPPResourceConnection` instance with all the server session data.
        `repo` - is a `NonAuthUserRepository` instance giving access to a part of the user repository which is accessible regardless the session is authenticated or not.
        `results` - is a packets `Queue` with all the processing results from the plugin.
        `settings` - is a `Map` with all the configuration settings passed to the plugin.
      Throws:
        `PacketErrorTypeException` - on attempt to send an error response to the error packet.

    - #### supDiscoFeatures

          public Element[] supDiscoFeatures​(XMPPResourceConnection session)

      Description copied from interface: `XMPPImplIfc`
      Method `supDiscoFeatures` returns an array of XML `Element`s with service discovery features which have to be returned to the client uppon request. Service discovery features returned by this method correspond to services supported by this plugin.
      Specified by:
        `supDiscoFeatures` in interface `XMPPImplIfc`
      Overrides:
        `supDiscoFeatures` in class `AnnotatedXMPPProcessor`
      Parameters:
        `session` - a `XMPPResourceConnection` value
      Returns:
        an `Element[]` value

    - #### supElementNamePaths

          public java.lang.String[][] supElementNamePaths()

      Description copied from interface: `XMPPImplIfc`
      Method `supElementNamePaths` returns an array of element names in form of a full path to the XML element for stanzas which can be processed by this plugin. Each element name path corresponds to XMLNS returned in array by `supNamespaces()` method. The element path itself is represented by a String array with each path element as a separate String.
      Specified by:
        `supElementNamePaths` in interface `XMPPImplIfc`
      Overrides:
        `supElementNamePaths` in class `AnnotatedXMPPProcessor`
      Returns:
        a `String[][]` value is an array for element paths for which the plugin offers processing capabilities. Each path is in form of a String array in order to reduce parsing overhead.

    - #### supNamespaces

          public java.lang.String[] supNamespaces()

      Description copied from interface: `XMPPImplIfc`
      Method `supNamespaces` returns an array of name-spaces for stanzas which can be processed by this plugin. Each namespace corresponds to element name returned in array by `supElemenets()` method.
      Specified by:
        `supNamespaces` in interface `XMPPImplIfc`
      Overrides:
        `supNamespaces` in class `AnnotatedXMPPProcessor`
      Returns:
        a `String[]` value